#if hNETCODE
using UnityEngine;
using Unity.Netcode;
using Unity.Netcode.Transports.UTP;

namespace Passer {

    public class NetcodeStarter : INetworkingStarter {
        public ushort serverPort;

        GameObject INetworkingStarter.GetHumanoidPrefab() {
            GameObject humanoidPrefab = Resources.Load<GameObject>("HumanoidPlayer");
            return humanoidPrefab;
        }

        void INetworkingStarter.StartHost(NetworkingStarter nwStarter) {
            Debug.Log("start Netcode Host");
            NetworkManager networkManager = nwStarter.GetComponent<NetworkManager>();
            if (networkManager == null) {
                Debug.LogError("Could not start host: NetworkManager is missing");
                return;
            }

            NetworkManager.Singleton.StartHost();
        }

        void INetworkingStarter.StartClient(NetworkingStarter nwStarter) {
            Debug.Log("start Netcode Client");
            NetworkManager.Singleton.GetComponent<UnityTransport>().SetConnectionData(
                nwStarter.serverIpAddress, 
                nwStarter.serverPort
                );
            NetworkManager.Singleton.StartClient();
        }

        public static void StartClient(string serverIpAddress, ushort serverPort) {
            Debug.Log("start Netcode Client");
                NetworkManager.Singleton.StartClient();
            NetworkManager.Singleton.GetComponent<UnityTransport>().SetConnectionData(
                serverIpAddress,
                serverPort
                );
        }

        void INetworkingStarter.StartClient(NetworkingStarter networking, string _roomName, int _gameVersion) {
        }

        public void StopClient() {; }

    }
}
#endif
